//*********************************************************************
//  payday.cpp - My attempt at the PayDay gag program
//  
//  Written by:   Daniel D. Miller
//  
//  Last Update:  08/21/07 03:54
//  
//  compile with makefile  
//*********************************************************************

#include <windows.h>
#include <string.h>
#include <math.h>
#include <sys/stat.h>

char *szClassName = "payday" ;

#include "wcommon.h"
#include "statbar.h"
#include "ezfont.h"
#include "payday.h"

// #define IDC_EDIT2    1003
// #define IDC_EDIT3    1004
#define IDC_STATIC1  1021
#define IDC_STATIC2  1022
#define IDC_STATIC3  1023
#define IDC_UPDATE   1031

//  why do I need this??
menu_select_s menu_select[] = {
{ 0         , "Unknown menu item" },
{ 0, NULL}} ;

//*********************************************************************
// variables

HWND hwnd;
HINSTANCE g_hInst;

//*************************************
#define  HEADER_Y    (20)

// #define  SLIDER_X    ( 30)
#define  SLIDER_Y    ( 40)

#define  SLIDER_DX   (300)
#define  SLIDER_DY   ( 30)

#define  LEFT_EDGE   ((DIALOG_DX-SLIDER_DX)/2)

#define  STATUS_Y    (100)

//*************************************
#define  STD_SPACE      20

#define  FIELD_LEN      400
#define  TAGOUT_LEN     FIELD_LEN
#define  NUMBER_LEN     50
#define  BUTTON_WIDTH   160

#define  FIELD_HEIGHT   22
#define  BUTTON_HEIGHT  (FIELD_HEIGHT + 10)
#define  NEXT_FIELD     (FIELD_HEIGHT + 10)

#define  REF_ROW        STD_SPACE
#define  SIG_ROW        (REF_ROW + NEXT_FIELD)
#define  PERIOD_ROW     (130)
#define  TAG_ROW        (PERIOD_ROW + NEXT_FIELD)
#define  STATUS_ROW     (TAG_ROW + NEXT_FIELD)

#define  LABEL_COL      STD_SPACE
#define  LABEL_LEN      350

#define  DATA_COL       (LABEL_LEN + 10)
#define  BUTTON_COL     (DATA_COL + NUMBER_LEN + STD_SPACE)

#define  DIALOG_DX   (800)
#define  DIALOG_DY   (600)

#define  DIALOG_X    (150)
#define  DIALOG_Y    (150)

//*************************************
char tempstr[260] ;

static HWND hwndStatic1;
static HWND hwndStatic2;
static HWND hwndStatic3;
static HWND hwndUpdate;
HWND hwndStatusBar;

// function prototypes
LRESULT APIENTRY MainProc (HWND, UINT, WPARAM, LPARAM);

unsigned cxClient = 0 ;
unsigned cyClient = 0 ;

//*********************************************************************
// initlize application
//*********************************************************************
static void InitApp (HINSTANCE hInst)
{
   WNDCLASS wc;
   wc.style = CS_HREDRAW | CS_VREDRAW;
   wc.cbClsExtra = 0;
   wc.cbWndExtra = 0;
   // wc.hbrBackground = (HBRUSH) GetStockObject (LTGRAY_BRUSH);
   wc.hbrBackground = (HBRUSH) (COLOR_BTNFACE+1) ;
   wc.hInstance = hInst;
   wc.hCursor = LoadCursor (NULL, IDC_ARROW);
   wc.hIcon = LoadIcon (hInst, MAKEINTRESOURCE(PAYDAY));
   wc.lpfnWndProc = (WNDPROC) MainProc;
   wc.lpszClassName = szClassName;
   wc.lpszMenuName = NULL;

   RegisterClass (&wc);

   hwnd = CreateWindow (szClassName, "Bonus Retrieval System", 
      WS_OVERLAPPED | WS_CAPTION | WS_SYSMENU | WS_MINIMIZEBOX,
      // WS_OVERLAPPEDWINDOW,
      DIALOG_X, DIALOG_Y, DIALOG_DX, DIALOG_DY, 0, 0, hInst, 0);

   ShowWindow (hwnd, SW_SHOW);
   UpdateWindow (hwnd);
}

//*********************************************************************
//  winmain entry point
//*********************************************************************
int APIENTRY WinMain (HINSTANCE hInst, HINSTANCE hPrev, LPSTR line,
   int CmdShow)
{
   MSG msg;
   g_hInst = hInst;
   InitApp (hInst);

   while (GetMessage (&msg, 0, 0, 0)) {
      TranslateMessage (&msg);
      DispatchMessage (&msg);
   }

   return msg.wParam;
}

//*********************************************************************
//  controls data
//*********************************************************************
#define  CPOS_LEFT   1
#define  CPOS_RIGHT  2
#define  CPOS_ABOVE  4
#define  CPOS_BELOW  8
#define  CPOS_ABOVE_LEFT   (CPOS_LEFT  | CPOS_ABOVE)
#define  CPOS_ABOVE_RIGHT  (CPOS_RIGHT | CPOS_ABOVE)
#define  CPOS_BELOW_LEFT   (CPOS_LEFT  | CPOS_BELOW)
#define  CPOS_BELOW_RIGHT  (CPOS_RIGHT | CPOS_BELOW)

int button_left = 0 ;
int button_top = 320 ;
int button_right = BUTTON_WIDTH ;
int button_bottom = 320 + BUTTON_HEIGHT - 1 ;
unsigned prev_x = 0 ;
unsigned prev_y = 0 ;
unsigned prev_pos = 0 ;
unsigned x_dist = 0 ;
unsigned y_dist = 0 ;

char *str1 = "It is that time of year!!" ;
static HFONT hfont1 ;
static char *font_name1 = "Times New Roman" ;
static unsigned fheight1 = 50 ;

char *str2 = "Yearly bonus checks are ready" ;
static HFONT hfont2 ;
static char *font_name2 = "Comic Sans MS" ;
static unsigned fheight2 = 50 ;

char *str3 = "Click the button to receive your bonus" ;
static HFONT hfont3 ;
static char *font_name3 = "ITC Zapf Chancery Medium Italic" ;
static unsigned fheight3 = 50 ;

// static char *pstr[16] = {
//    "0", "L", "R", "3", "A", "AL", "AR", "7", 
//    "B", "BL", "BR", "11", "12", "13", "14", "15"
// } ;
// char msgstr[128] ;   //  string for debug messages

//*********************************************************************
static void adjust_in_y(int cx)
{
   if (cx > 0) {  //  we're moving down in Y (same as CPOS_ABOVE)
      button_top += cx + 5 ;
      button_bottom = button_top + BUTTON_HEIGHT - 1 ;
      if (button_bottom >= (int) (cyClient-3)) {
         button_top = 2;
         button_bottom = button_top + BUTTON_HEIGHT - 1 ;
      }
   } else 
   if (cx < 0) {
      if (button_top < 7) {
         button_top = cyClient - BUTTON_HEIGHT - 3 ;
      } else {
         button_top -= cx + 5 ;
      }
      button_bottom = button_top + BUTTON_HEIGHT - 1 ;
   }
}

static void adjust_in_x(int cx)
{
   if (cx > 0) {  //  we're moving toward the right
      button_left += cx + 5 ;
      button_right = button_left + BUTTON_WIDTH - 1 ;
      if (button_right >= (int) cxClient) {
         button_left = 2;
         button_right = button_left + BUTTON_WIDTH - 1 ;
      }
   } else
   if (cx < 0) {
      cx = -cx ;
      if (button_left < 7) {
         button_left = cxClient - BUTTON_WIDTH - 3 ;
      } else {
         button_left -= cx + 5 ;
      }
   }
}

static void move_up(int cx)
{
   if (button_top < 7) {
      button_top = cyClient - BUTTON_HEIGHT - 3 ;
   } else {
      button_top -= cx + 5 ;
   }
   button_bottom = button_top + BUTTON_HEIGHT - 1 ;
}

static void move_down(int cx)
{
   button_top += cx + 5 ;
   button_bottom = button_top + BUTTON_HEIGHT - 1 ;
   if (button_bottom >= (int) (cyClient-3)) {
      button_top = 2;
      button_bottom = button_top + BUTTON_HEIGHT - 1 ;
   }
}

static void move_right(int cx)
{
   button_left += cx + 5 ;
   button_right = button_left + BUTTON_WIDTH - 1 ;
   if (button_right >= (int) cxClient) {
      button_left = 2;
      button_right = button_left + BUTTON_WIDTH - 1 ;
   }
}

static void move_left(int cx)
{
   if (button_left < 7) {
      button_left = cxClient - BUTTON_WIDTH - 3 ;
   } else {
      button_left -= cx + 5 ;
   }
   button_right = button_left + BUTTON_WIDTH - 1 ;
}

//*********************************************************************
static void move_button(POINT *cpos, RECT *mrect)
{
   int cx ;
   // wsprintf(tempstr, " p=%u", prev_pos) ;
   // StatusBar_SetText(hwndStatusBar, 2, 0, tempstr) ;
   switch (prev_pos) {
   case CPOS_LEFT:
      cx = cpos->x - mrect->left ;
      // wsprintf(tempstr, " cxL=%u", cx) ;
      // StatusBar_SetText(hwndStatusBar, 1, 0, tempstr) ;
      move_right(cx) ;

      //  deal with lateral movement
      cx = cpos->y - prev_y ;
      adjust_in_y(cx) ;

      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_RIGHT:
      cx = mrect->right - cpos->x ;
      wsprintf(tempstr, " cx=%d", cx) ;
      StatusBar_SetText(hwndStatusBar, 1, 0, tempstr) ;
      wsprintf(tempstr, " r=%u/%u/%u", button_left, mrect->right, cpos->x) ;
      StatusBar_SetText(hwndStatusBar, 2, 0, tempstr) ;
      move_left(cx) ;

      //  deal with lateral movement
      cx = cpos->y - prev_y ;
      adjust_in_y(cx) ;

      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_ABOVE:
      cx = cpos->y - mrect->top ;
      // wsprintf(tempstr, " bb=%u", button_bottom) ;
      // StatusBar_SetText(hwndStatusBar, 1, 0, tempstr) ;
      // wsprintf(tempstr, " cy=%d/%u", cy, cyClient) ;
      // StatusBar_SetText(hwndStatusBar, 2, 0, tempstr) ;
      move_down(cx) ;

      //  also, deal with lateral change
      cx = cpos->x - prev_x ;
      adjust_in_x(cx) ;

      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_BELOW:
      cx = mrect->bottom - cpos->y ;
      move_up(cx) ;

      //  also, deal with lateral change
      cx = cpos->x - prev_x ;
      wsprintf(tempstr, " CX=%d", cx) ;
      StatusBar_SetText(hwndStatusBar, 1, 0, tempstr) ;
      wsprintf(tempstr, " B=%d/%u/%u", button_left, prev_x, cpos->x) ;
      StatusBar_SetText(hwndStatusBar, 2, 0, tempstr) ;
      adjust_in_x(cx) ;

      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_ABOVE_LEFT:
      cx = cpos->y - mrect->top ;
      move_down(cx) ;
      cx = cpos->x - mrect->left ;
      move_right(cx) ;
      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_ABOVE_RIGHT:
      cx = cpos->y - mrect->top ;
      move_down(cx) ;
      cx = mrect->right - cpos->x ;
      move_left(cx) ;
      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_BELOW_LEFT:
      cx = mrect->bottom - cpos->y ;
      move_up(cx) ;
      cx = cpos->x - mrect->left ;
      move_right(cx) ;
      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;

   case CPOS_BELOW_RIGHT:
      cx = mrect->bottom - cpos->y ;
      move_up(cx) ;
      cx = mrect->right - cpos->x ;
      move_left(cx) ;
      MoveWindow(hwndUpdate, button_left, button_top, 
         BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
      break;
   }  //  switch on previous position
}

//*********************************************************************
// Main Process CallBack Function
//*********************************************************************
LRESULT APIENTRY MainProc (HWND hwnd, UINT msg, WPARAM wParam, LPARAM lParam)
{
   // DWORD dwPos ;
   PAINTSTRUCT ps;
   int cx, cy ;
   static int sbparts[3] ;
   SIZE ssize ;
   HDC hdc ;
   static int statics_created = 0 ;
   // char pos_str[81] ;
   // int len ;
   unsigned position ;
   POINT px ;
   RECT mrect ;
   static int got_hittest = 0 ;
   POINT px_client_screen ;

	switch (msg) {
      
   //*******************************************************************
   //  And then, of course, I cannot detect my cursor position
   //  in client-window coordinates, within WM_SETCURSOR.
   //  
   //  Later: actually, ClientToScreen() would have given me that,
   //  but I've already solved the problems in other ways...
   //  
   //  I did notice a difference in event sequence between 
   //  "outside the button" and "inside the button"...
   //  Outside the button, I get these messages:
   //    WM_NCHITTEST -> WM_SETCURSOR -> WM_MOUSEMOVE
   //  Inside the button, I *ONLY* get WM_SETCURSOR.
   //  So, for now, I'm detecting and acting on
   //  "WM_SETCURSOR received without WM_NCHITTEST".
   //  This is pretty hackish, but I don't know any better way.
   //  
   //  Maybe I should just skip WM_MOUSEMOVE, and do *all*
   //  detection here in WM_SETCURSOR  ??  
   //  That looks like it will work
   //*******************************************************************
   case WM_NCHITTEST:
      got_hittest = 1 ;
      return DefWindowProc (hwnd, msg, wParam, lParam);
      
   case WM_SETCURSOR:
      // GetClientRect(hwnd, &mrect) ; //  reports 0,0
//       wsprintf(msgstr, "L%u, T%u\n", mrect.left, mrect.top) ;
//       OutputDebugString(msgstr) ;   
      
      //  some of these functions could be done in WM_SIZE,
      //  or by trapping window movement, and save a little time.
      //  Since performance isn't really an issue here, 
      //  I'm not going to worry about it for now.
      GetWindowRect(hwndUpdate, &mrect) ; //  reports outer window 
      GetCursorPos(&px) ;  //  this is in desktop coordinates!!
      px_client_screen.x = cxClient ;
      px_client_screen.y = cyClient ;
      ClientToScreen(hwnd, &px_client_screen) ;

      if (!got_hittest) {
         // wsprintf(msgstr, "within button [%s]\n", pstr[prev_pos]) ;
         // OutputDebugString(msgstr) ;   
         
         //*******************************************************
         // button is reacting to cursor at bottom of screen,
         // even when nowhere NEAR the button!!
         //  That's because we get the same "WM_SETCURSOR without
         //  WM_NCHITTEST" condition in the statbar area, that we
         //  get within the button, but it *doesn't* mean that!!
         //*******************************************************
         if (px.y < (int) (px_client_screen.y-1)  &&  
             px.x < (int) (px_client_screen.x-1)) {
            // StatusBar_SetText(hwndStatusBar, 2, 0, "0") ;   //  clear the field
            move_button(&px, &mrect) ;
         }
      } else {
         // StatusBar_SetText(hwndStatusBar, 2, 0, "1") ;   //  clear the field
         cx = px.x ;
         cy = px.y ;
         position = 0 ;
         x_dist = y_dist = 0 ;
         if (cx < mrect.left) {
            // len += wsprintf(&pos_str[len], " left") ;
            position |= CPOS_LEFT ;
            x_dist = (unsigned) mrect.left - cx ;
         } else
         if (cx > mrect.right) {
            // len += wsprintf(&pos_str[len], " right") ;
            position |= CPOS_RIGHT ;
            x_dist = cx - (unsigned) mrect.right ;
         }
         if (cy < mrect.top) {
            // if (len > 0) 
            //    len += wsprintf(&pos_str[len], ",") ;
            // len += wsprintf(&pos_str[len], " above") ;
            position |= CPOS_ABOVE ;
            y_dist = (unsigned) mrect.top - cy ;
         } else
         if (cy > mrect.bottom) {
            // if (len > 0) 
            //    len += wsprintf(&pos_str[len], ",") ;
            // len += wsprintf(&pos_str[len], " below") ;
            position |= CPOS_BELOW ;
            y_dist = cy - (unsigned) mrect.bottom ;
         }
         // if (len == 0) {
         //    len += wsprintf(&pos_str[len], " on button ") ;
         // }
         // Statusbar_ShowMessage(pos_str) ;
         // wsprintf(pos_str, "pos=%s, x_dist=%u, btop=%d", 
         //    pstr[position], x_dist, button_top) ;
         // Statusbar_ShowMessage(pos_str) ;
         
         if (position != 0) {
            prev_x = px.x ;
            prev_y = px.y ;
            prev_pos = position ;
         } else {
            //  if position == 0, we should probably do something here.
            //  I think this is why I keep lapsing into the button area.
            //  That works, but now edge detection doesn't always work...
            if (px.y < (int) (px_client_screen.y-1)  &&  
                px.x < (int) (px_client_screen.x-1)) {
               move_button(&px, &mrect) ;
            }
         }
      }
      got_hittest = 0 ;
      
      //  how do I find screen position of upper-left client area??
      //  Apparently, I don't...
      //  Later: actually, ClientToScreen() would have given me that,
      //  but I've already solved the problems in other ways...
      // wsprintf(tempstr, " X=%u", px.x) ;
      // StatusBar_SetText(hwndStatusBar, 1, 0, tempstr) ;
      // wsprintf(tempstr, " Y=%u", px.y) ;
      // StatusBar_SetText(hwndStatusBar, 2, 0, tempstr) ;
      return DefWindowProc (hwnd, msg, wParam, lParam);
      // break;
      
   //*******************************************************************
   //  interesting note: I *stop* getting WM_MOUSEMOVE 
   //  messages once the mouse moves over the button!!
   //  I wonder what message I *am* getting??
   //  VC6 Spy++ doesn't show ANY messages in the main window...
   //  
   //  For now, I'll try to just handle the messages and move
   //  the button *before* the mouse moves over it, which is
   //  what I intended anyway...
   //  Of course, that didn't work - Windows confounded me again.
   //  I often get onto the button without detecting (distance == 1).
   //*******************************************************************
//    case WM_MOUSEMOVE:
//       cx = LOWORD (lParam) ;
//       cy = HIWORD (lParam) ;
// 
//       // wsprintf(tempstr, " X=%u", cx) ;
//       // StatusBar_SetText(hwndStatusBar, 1, 0, tempstr) ;
//       // wsprintf(tempstr, " Y=%u", cy) ;
//       // StatusBar_SetText(hwndStatusBar, 2, 0, tempstr) ;
// 
//       // len = 0 ;
//       position = find_position(cx, cy) ;
// 
//       //  okay, see if we're getting too close to the button
//       wsprintf(pos_str, "pos=%s, x_dist=%u", pstr[position], x_dist) ;
//       Statusbar_ShowMessage(pos_str) ;
//       // switch (position) {
//       // case 1:  //  left
//       //    if (x_dist == 1) {
//       //       button_left += 5 ;
//       //       button_right = button_left + BUTTON_WIDTH - 1 ;
//       // 
//       //       MoveWindow(hwndUpdate, button_left, button_top, 
//       //          BUTTON_WIDTH, BUTTON_HEIGHT, TRUE) ;
//       //    }
//       //    break;
//       // }
// 
//       //  save current position for future reference
//       prev_x = cx ;
//       prev_y = cy ;
//       prev_pos = position ;
//       break;

   case WM_CREATE:
      // Create status bar (source resides in statbar.c).
      hwndStatusBar = InitStatusBar (hwnd, NO_RESIZE) ;

      //  buttons
      cx = ((unsigned) DIALOG_DX - (unsigned) BUTTON_WIDTH) / 2 ;
      button_left = cx ;
      button_right = button_left + BUTTON_WIDTH - 1 ;
      hwndUpdate = CreateButton ("receive bonus", cx, 320, BUTTON_WIDTH, BUTTON_HEIGHT, IDC_UPDATE, hwnd, g_hInst);

      // wsprintf(msgstr, "L%u, T%u, R%u, B%u\n", button_left, button_top, 
      //    button_right, button_bottom) ;
      // OutputDebugString(msgstr) ;
      break;

   case WM_SIZE:
      cxClient = LOWORD (lParam);
      cyClient = HIWORD (lParam);

      // Adjust status bar size.
      if (IsWindowVisible (hwndStatusBar)) {
         RECT rWindow ;
         int nHeight ;

         GetWindowRect (hwndStatusBar, &rWindow) ;
         nHeight = rWindow.bottom - rWindow.top ;
         MoveWindow (hwndStatusBar, 0, cyClient - nHeight, cxClient, nHeight, TRUE) ;
         cyClient -= nHeight ;

         //  re-position status-bar parts
         // sbparts[0] = 6 * cx / 10 ;
         // sbparts[1] = 8 * cx / 10 ;
         sbparts[0] = cxClient - 200 ;
         sbparts[1] = cxClient - 100 ;
         sbparts[2] = -1 ;
         StatusBar_SetParts(hwndStatusBar, 3, &sbparts[0]) ;
      }
      // maxx = cxClient - 1;
      // maxy = cyClient - 1;

      //  re-position the statics
      if (!statics_created) {
         statics_created = 1 ;
         hdc = GetDC(hwnd) ;

         //  first line
         hfont1 = build_font(font_name1, fheight1, 0, 0, 0, 0) ;
         SelectObject (hdc, hfont1) ;
         GetTextExtentPoint32(hdc, str1, strlen(str1), &ssize) ;
         // DeleteObject (SelectObject (hdc, GetStockObject (SYSTEM_FONT)));
         cx = ((unsigned) DIALOG_DX - (unsigned) ssize.cx) / 2 ;
         // wsprintf(msgstr, "new width=%u (strlen=%u), cx=%u\n", 
         //    ssize.cx, strlen(str1), cx) ;
         // OutputDebugString(msgstr) ;
         hwndStatic1 = CreateStatic(str1, cx, 80, ssize.cx+20, fheight1, IDC_STATIC1, hwnd, g_hInst);
         SendMessage(hwndStatic1, WM_SETFONT, (WPARAM) hfont1, MAKELPARAM(FALSE, 0)); 

         //  second line
         hfont2 = build_font(font_name2, fheight2, 0, 0, 0, 0) ;
         SelectObject (hdc, hfont2) ;
         GetTextExtentPoint32(hdc, str2, strlen(str2), &ssize) ;
         // DeleteObject (SelectObject (hdc, GetStockObject (SYSTEM_FONT)));
         cx = ((unsigned) DIALOG_DX - (unsigned) ssize.cx) / 2 ;
         hwndStatic2 = CreateStatic (str2, cx, 160, ssize.cx+20, fheight2, IDC_STATIC2, hwnd, g_hInst);
         SendMessage(hwndStatic2, WM_SETFONT, (WPARAM) hfont2, MAKELPARAM(FALSE, 0)); 

         //  third line
         hfont3 = build_font(font_name3, fheight3, 0, 0, 0, 0) ;
         SelectObject (hdc, hfont3) ;
         GetTextExtentPoint32(hdc, str3, strlen(str3), &ssize) ;
         // DeleteObject (SelectObject (hdc, GetStockObject (SYSTEM_FONT)));
         cx = ((unsigned) DIALOG_DX - (unsigned) ssize.cx) / 2 ;
         hwndStatic3 = CreateStatic (str3, cx, 240, ssize.cx+20, fheight3, IDC_STATIC3, hwnd, g_hInst);
         SendMessage(hwndStatic3, WM_SETFONT, (WPARAM) hfont3, MAKELPARAM(FALSE, 0)); 

         ReleaseDC (hwnd, hdc) ;
      }
      SetCursorPos(button_left, button_bottom+50) ;

      break;

   case WM_SETFOCUS:
      // update_timer_count(hwnd) ;
      // OutputDebugString("SetFocus\n") ;
      break;

   case WM_PAINT:
      BeginPaint (hwnd, &ps) ;
      // update_timer_count(hwnd) ;
      EndPaint (hwnd, &ps) ;
      break;
    
   case WM_KEYDOWN:
   case WM_SYSKEYDOWN:
      if (wParam == 27) {
         SendMessage(hwnd, WM_DESTROY, 0, 0) ;
      }
      return 0;

   case WM_DESTROY:
      PostQuitMessage (0);
      break;

   default:
      //  I'm getting (and not handling) messages 32 and 132...
      //  Within the button, I *only* get 32...
// #define WM_SETCURSOR 32
// #define WM_NCHITTEST 132
      // wsprintf(msgstr, "msg %u\n", msg) ;
      // OutputDebugString(msgstr) ;
      return DefWindowProc (hwnd, msg, wParam, lParam);
	}
	return 0;
}

